//  ==================================================================================================
//  Session     : ReceivePicking_1.pas (Receiving Picking List--insert data)
//  Author      : LJ Chen
//  Create Date : 2004/03/10
//
//  ==================================================================================================
//      Modify ID     Author            Modify Purpose
//      ---------   --------------    ----------------------------------------------------------------
//      040419-01   Dan Chiou         Add customer item check function
//      040310-01   LJ Chen           Create ReceivePicking Session for Receiving Picking List(insert data)
//      040707-01   Dan Chiou         Add exception handling
//  ==================================================================================================

unit ReceivePickingSF_1;

interface
uses
  Windows, Messages, Sysutils, Classes, Graphics, Controls, Forms, Dialogs, bvUtil,
  Dbtables, Db, Stdctrls, Filectrl, Inifiles, Phio, Phbasic, Extctrls, ComCtrls;

type
  TFrmReceivePicking_1 = class(TForm)
    DBcms: TDatabase;
    DBTriton: TDatabase;
    QDS: TQuery;
    QDS_Session: TSession;
    ProgressBar: TProgressBar;
    Memo_Receive_Picking_Data: TMemo;
    Process_Status_Line: TLabel;
    Count: TEdit;
    Status_Bar: TEdit;
    Timer1: TTimer;
    procedure FormCreate(Sender: Tobject);
    procedure FormActivate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    procedure Update_Cds_Error(DataSet: Tdataset; E: EDataBaseError; UpdateKind: TUpdateKind; var UpdateAction: TUpdateAction);
    procedure Show_Memo_Line_Data(Par_Momo_Data: string);
    function Create_Cds(Par_DbName: string; Par_Owner: Tcomponent; const Par_Name: string = ''): Tquery;
    function Cds_Execute(var Par_CdsDb: Tdatabase; var Par_Cds: Tquery): Boolean;
    procedure Receive_Picking_Data;
    function Prepare_Set_Status(Par_NCMP, Par_PINO: Integer): Boolean;
    function Update_Error_Log(Par_NCMP, Par_PINO: Integer; Par_CUNO, Par_DSCA: string): Boolean;
    procedure Next_Process;
    { Private Declarations }
  public
    function Q_Open(MYquery: Tquery; mSQL: string): Boolean;
    procedure Q_Execute(MYquery: Tquery; mSQL: string);
    function GetLine(var MultiLines: Variant; N: integer): string;
    function Session_Constraint(Par_ses, Par_constra: WideString; const Par_Para: WideString = ''): WideString;
    function Assign_Number(const GroupNCMP, PARA: WideString): Integer;
    function CreateQuery(mDBname: string; mOWNER: Tcomponent; const mName: string = ''): Tquery;
    procedure QueryUpdateError(DataSet: TDataSet; E: EDatabaseError; UpdateKind: TUpdateKind;
      var UpdateAction: TUpdateAction);
    function Cds_Open(Par_Cds: Tquery; Par_Sql: string): Boolean;
    { Public Declarations }
  end;

var
  FrmReceivePicking_1: TFrmReceivePicking_1;
  Us_LOGFILE_ON_OFF, Us_LOGFILE_PATH: string;
  Par_NCMP, Par_PINO, Par_ORNO, Par_PONO, Par_GRUP: Integer;
  Par_CUNO, Par_DSCA, Par_PTYP: string;
implementation

{$R *.dfm}

var
  cdsCMS, Cds_CTmp, Cds_Tmp, Cds_CSav, Cds_TTmp: TQuery;

procedure TFrmReceivePicking_1.Receive_Picking_Data;
var
  Lines: Variant;
  C002, C021, C022, C029, C062, C066, C067, C071, C101, T000, T012: Tquery;
  Par_CFRW, T_CSEL, HCUNO, strbuf, strITEM, result, MPAK: string;
  mCommit, isPDD: boolean;
  EPS_prepare, mEPSflag, ISAME_ADD: WordBool;
  Par_DDTA: TDateTime;
  Par_USER, Par_SESID, Par_APAR,Par_CCOR: string;
  nCountT21: Integer;
  procedure DoUPdateCMPPS021;
  begin
    C021.Edit;
    C021.FieldByName('RUNID').Asstring := Par_PTYP;
    C021.FieldByName('STATUS').Asinteger := 0;
    C021.FieldByName('EPS_PAKNO').Asstring := '';
    C021.FieldByName('INVN').Asstring := CDS_CTmp.Fieldbyname('TTYP').Asstring + CDS_CTmp.Fieldbyname('INVN').Asstring;
    C021.FieldByName('ORNO').Asstring := IntToStr(CDS_CTmp.Fieldbyname('ORNO').Asinteger);
    C021.FieldByName('COTP').Asstring := CDS_CTmp.Fieldbyname('COTP').Asstring;
    C021.FieldByName('CORG').Asstring := IntToStr(CDS_CTmp.Fieldbyname('CORG').Asinteger);
    C021.FieldByName('MPAK').Asstring := MPAK;
    C021.FieldByName('CRTE').Asstring := TRIM(CDS_CTmp.Fieldbyname('CRTE').Asstring);
    C021.FieldByName('CFRW').Asstring := Par_CFRW;
    C021.FieldByName('REFA').Asstring := CDS_CTmp.Fieldbyname('REFA').Asstring;
    C021.FieldByName('CUNO').Asstring := CDS_CTmp.Fieldbyname('CUNO').Asstring;
    C021.FieldByName('WBIL').AsInteger := StrToInt(Get000(IntToStr(Par_PINO), 6));
    C021.FieldByName('FILE_DESADV').AsString := 'N';
    C021.FieldByName('FILE_ACS').AsString := 'N';
    C021.FieldByName('PDD').AsString := 'N';
    C021.FieldByName('SERI_NO').AsInteger := 1;
    C021.FieldByName('ACTNO').AsString := '';
    C021.FieldByName('HAWB').AsString := '';
    C021.FieldByName('OMCU').AsString := CDS_CTmp.FieldByName('OMCU').AsString;
    C021.FieldByName('INST').AsString := CDS_CTmp.FieldByName('INST').AsString;
    C021.FieldByName('HCUNO').Asstring := CDS_CTmp.Fieldbyname('OCST').Asstring;
    if Cds_Open(T000, '0SELECT T$BARC FROM TRITON.TTCCOM910' + Get000(IntToStr(Par_NCMP), 3)
                    + '  WHERE T$CUNO = '+ QuotedStr(CDS_CTmp.Fieldbyname('CUNO').asstring)) and
               (T000.Fieldbyname('T$BARC').Asinteger = 2) then
      C021.FieldByName('BARC').Asstring := 'N'
    else C021.FieldByName('BARC').Asstring := 'Y';
    if CDS_CTmp.FieldByname('INVD').AsString = '' then C021.FieldByName('INVD').AsString := ''
    else C021.FieldByName('INVD').Value := FormatDateTime('YYYY/MM/DD', CDS_CTmp.FieldByname('INVD').Value);
  end;

  procedure fp_InsertCMPPS08X(Par_NCMP, Par_ORNO, Par_PINO, Par_PONO: string);
  var Par_PRIC, sSQL: String;
  begin
    // Insert Into CMPPS080
    if not CDS_Open(cdsCMS, 'SELECT * FROM CMPPS080'
                          + ' WHERE NCMP = '+ Par_NCMP
                          + '   AND PINO = '+ Par_PINO) then
    begin
      if CDS_Open(T000, '0SELECT T080.T$TTYP, T080.T$INVN, T080.T$CURR,              '
                      + '        T080.T$CDEC, T080.T$DSCA, T080.T$CPAY,              '
                      + '        T080.T$PDSC, T080.T$SCIR, T080.T$COMP, T081.T$SCIP  '
                      + '   FROM TRITON.TTDEPS080' + Get000(IntToStr(Par_GRUP), 3) + ' T080,'
                      + '        TRITON.TTDEPS081' + Get000(IntToStr(Par_GRUP), 3) + ' T081 '
                      + '  WHERE T081.T$COMP = T080.T$COMP '
                      + '    AND T081.T$TTYP = T080.T$TTYP '
                      + '    AND T081.T$INVN = T080.T$INVN '
                      + '    AND T081.T$PONO = '+ Par_PONO
                      + '    AND T081.T$SRNB = '+ CDS_Tmp.Fieldbyname('SRNB').AsString
                      + '    AND T080.T$COMP = '+ Par_NCMP
                      + '    AND T080.T$ORNO = '+ Par_ORNO) then
      begin
        cdsCMS.Append;
        cdsCMS.FieldByName('NCMP').Value := T000.FieldByName('T$COMP').Value;
        cdsCMS.FieldByName('PINO').Value := Par_PINO;
        cdsCMS.FieldByName('INVN').AsString := T000.FieldByName('T$TTYP').AsString
                                             + Get000(T000.FieldByName('T$INVN').AsString, 8);
        cdsCMS.FieldByName('CURR').Value := T000.FieldByName('T$CURR').Value;
        cdsCMS.FieldByName('CDEC').Value := T000.FieldByName('T$CDEC').Value;
        cdsCMS.FieldByName('DDSC').Value := T000.FieldByName('T$DSCA').Value;
        cdsCMS.FieldByName('CPAY').Value := T000.FieldByName('T$CPAY').Value;
        cdsCMS.FieldByName('PDSC').Value := T000.FieldByName('T$PDSC').Value;
        cdsCMS.FieldByName('SCIR').Value := T000.FieldByName('T$SCIR').Value;
        Par_PRIC := T000.FieldByName('T$SCIP').Value;
        cdsCMS.POST;
        cdsCMS.ApplyUpdates;
      end;

      { else
        begin
          Show_Memo_Line_Data(format(' This ORNO: %S '+ #13
                                    + ' EPS Invoice Head Data Is Null'
                                    + ' (Ref. CMPPS080 Table)', [Par_ORNO]));
          Abort;
        end;
      }
      end;
    // Insert into CMPPS081
    if not CDS_Open(cdsCMS, 'SELECT * FROM CMPPS081 '
                          + ' WHERE NCMP = '+ Par_NCMP
                          + '   AND ORNO = '+ Par_ORNO
                          + '   AND PONO = '+ Par_PONO) then
    begin
      if (CDS_Open(T000, '0SELECT T$ORNO, T$PONO, T$ITEM, T$REFD, '
                       + '        T$REFC, T$CPON, T$CPON, T$CPRT, '
                       + '        T$CUMN, T$CITM, T$CUIT, T$TREF, '
                       + '        T$COPO, T$CSOL, T$SOLN, T$SLCD, '
                       + '        TO_DATE(DECODE(TO_CHAR(T$RQDT,''YYYY/MM/DD''),''9999/01/01'',NULL,TO_CHAR(T$RQDT,''YYYY/MM/DD'')),''YYYY/MM/DD'') T$RQDT, '
                       + '        T$UPCC, T$DELG, T$SOSL, T$SCIP  '
                       + '   FROM TRITON.TTDSLS941' + Get000(Par_NCMP, 3)
                       + '  WHERE T$ORNO = '+ Par_ORNO
                       + '    AND T$PONO = '+ Par_PONO)) then
      begin
        cdsCMS.Append;
        cdsCMS.FieldByName('NCMP').AsString := Par_NCMP;
        cdsCMS.FieldByName('ORNO').AsString := T000.FieldByName('T$ORNO').AsString;
        cdsCMS.FieldByName('PONO').AsString := T000.FieldByName('T$PONO').AsString;
        cdsCMS.FieldByName('ITEM').AsString := Trim(T000.FieldByName('T$ITEM').AsString);
        cdsCMS.FieldByName('REFD').AsString := Trim(T000.FieldByName('T$REFD').AsString);
        cdsCMS.FieldByName('REFC').AsString := Trim(T000.FieldByName('T$REFC').AsString);
        cdsCMS.FieldByName('CPON').AsString := Trim(T000.FieldByName('T$CPON').AsString);
        cdsCMS.FieldByName('CPRT').AsString := Trim(T000.FieldByName('T$CPRT').AsString);
        cdsCMS.FieldByName('CUMN').AsString := Trim(T000.FieldByName('T$CUMN').AsString);
        cdsCMS.FieldByName('CITM').AsString := Trim(T000.FieldByName('T$CITM').AsString);
        cdsCMS.FieldByName('CUIT').AsString := Trim(T000.FieldByName('T$CUIT').AsString);
        cdsCMS.FieldByName('TREF').AsString := Trim(T000.FieldByName('T$TREF').AsString);
        cdsCMS.FieldByName('COPO').AsString := Trim(T000.FieldByName('T$COPO').AsString);
        cdsCMS.FieldByName('CSOL').AsString := Trim(T000.FieldByName('T$CSOL').AsString);
        cdsCMS.FieldByName('SOLN').AsString := Trim(T000.FieldByName('T$SOLN').AsString);
        cdsCMS.FieldByName('SLCD').AsString := Trim(T000.FieldByName('T$SLCD').AsString);
        cdsCMS.FieldByName('RQDT').AsString := Trim(T000.FieldByName('T$RQDT').AsString);
        cdsCMS.FieldByName('UPCC').AsString := Trim(T000.FieldByName('T$UPCC').AsString);
        cdsCMS.FieldByName('DELG').AsString := Trim(T000.FieldByName('T$DELG').AsString);
        cdsCMS.FieldByName('SOSL').AsString := Trim(T000.FieldByName('T$SOSL').AsString);
        cdsCMS.FieldByName('SCIP').AsString := Par_PRIC;
        cdsCMS.FieldByName('DDTA').AsDateTime := Par_DDTA;
        cdsCMS.FieldByName('APAR').AsString := Par_APAR;
      end;
        if CDS_Open(T000, '0SELECT T$CODT FROM TRITON.TTDSLS981' + Get000(Par_NCMP, 3)
                        + '  WHERE T$ORNO = '+ Par_ORNO) then
        begin
          cdsCMS.FieldByName('CODT').Value := T000.FieldByName('T$CODT').Value;
          cdsCMS.POST;
          cdsCMS.ApplyUpdates;
        end;
    end;

    // INSERT CMPPS082
{   if not Q_Open(C082, 'SELECT * FROM CMPPS082 '
                      + ' WHERE NCMP = '+ Par_NCMP
                      + '   AND PINO = '+ Par_PINO) then
    begin
      if Q_Open(T000, '0SELECT T988.T$COMP, T988.T$TTYP, T988.T$INVN, T988.T$ORNO, T988.T$CUNO, T988.T$REFA, '
                    + '        T988.T$CCUR, T988.T$CPAY, T988.T$CDEC, T988.T$DDSC, T988.T$PDSC, T988.T$INVD  '
                    + '   FROM TRITON.TTDSLS988' + Get000(Par_NCMP, 3) + ' T988,                             '
                    + '        TRITON.TTDSLS989' + Get000(Par_NCMP, 3) + ' T989                              '
                    + '  WHERE T988.T$COMP = T989.T$COMP                                                     '
                    + '    AND T988.T$TTYP = T989.T$TTYP                                                     '
                    + '    AND T988.T$INVN = T989.T$INVN                                                     '
                    + '    AND T988.T$ORNO = T989.T$ORNO                                                     '
                    + '    AND T989.T$SORN = '+ Par_ORNO
                    + '    AND T989.T$SPON = '+ Par_PONO
                    + '    AND T989.T$SSEQ = '+ CDS_Tmp.Fieldbyname('SRNB').AsString) then
      begin
        C082.Append;
        C082.FieldByName('NCMP').AsString := Par_NCMP;
        C082.FieldByName('PINO').Value := Par_PINO;
        C082.FieldByName('COMP').Value := T000.FieldByName('T$COMP').Value;
        C082.FieldByName('INVN').Value := T000.FieldByName('T$TTYP').Value
                                 + Get000(T000.FieldByName('T$INVN').Value, 8);
        C082.FieldByName('ORNO').Value := T000.FieldByName('T$ORNO').Value;
        C082.FieldByName('CUNO').Value := T000.FieldByName('T$CUNO').Value;
        C082.FieldByName('REFA').Value := T000.FieldByName('T$REFA').Value;
        C082.FieldByName('CCUR').Value := T000.FieldByName('T$CCUR').Value;
        C082.FieldByName('CPAY').Value := T000.FieldByName('T$CPAY').Value;
        C082.FieldByName('CDEC').Value := T000.FieldByName('T$CDEC').Value;
        C082.FieldByName('DDSC').Value := T000.FieldByName('T$DDSC').Value;
        if T000.FieldByname('T$INVD').AsString = '' then C082.FieldByName('INVD').AsString := ''
        else C082.FieldByName('INVD').Value := FormatDateTime('YYYY/MM/DD', T000.FieldByname('T$INVD').Value);
        C082.POST;
        C082.ApplyUpdates;
      end;
    end;
}
    // INSERT CMPPS083
    if not CDS_Open(cdsCMS, 'SELECT * FROM CMPPS083 '
                          + ' WHERE NCMP = '+ Par_NCMP
                          + '   AND PINO = '+ Par_PINO) then
    begin
      cdsCMS.Append;
      cdsCMS.FieldByName('NCMP').AsInteger := StrToInt(Par_NCMP);
      cdsCMS.FieldByName('PINO').AsInteger := StrToInt(Par_PINO);
      cdsCMS.FieldByName('CCOR').Value := Par_CCOR;
      if CDS_Open(T000, '0SELECT * FROM TRITON.TTDSLS042' + Get000(Par_NCMP, 3)
                      + '  WHERE T$ORNO = '+ Par_ORNO
                      + '    AND T$CKOR = 1') then
      begin
        cdsCMS.FieldByName('NAMA').Value := T000.fieldbyname('T$NAMA').Value;
        cdsCMS.FieldByName('NAMB').Value := T000.fieldbyname('T$NAMB').Value;
        cdsCMS.FieldByName('NAMC').Value := T000.fieldbyname('T$NAMC').Value;
        cdsCMS.FieldByName('NAMD').Value := T000.fieldbyname('T$NAMD').Value;
        cdsCMS.FieldByName('NAME').Value := T000.fieldbyname('T$NAME').Value;
        cdsCMS.FieldByName('NAMF').Value := T000.fieldbyname('T$NAMF').Value;
        cdsCMS.FieldByName('CCTY').Value := T000.fieldbyname('T$CCTY').Value;
        cdsCMS.FieldByName('PSTC').Value := T000.fieldbyname('T$PSTC').Value;
        cdsCMS.POST;
        cdsCMS.ApplyUpdates;
        C029.FieldByName('BILL_CCTY').Value := T000.Fieldbyname('T$CCTY').Value;
      end
      else if Par_CCOR <> '' then
      begin
        if CDS_Open(T012, '0SELECT * FROM TRITON.TTCCOM012' + Get000(IntToStr(Par_GRUP), 3)
                        + '  WHERE T$CUNO = '+ QuotedStr(Par_CUNO)
                        + '    AND T$CCOR = '+ QuotedStr(Par_CCOR)) then
        begin
          cdsCMS.FieldByName('NAMA').Value := T012.fieldbyname('T$NAMA').Value;
          cdsCMS.FieldByName('NAMB').Value := T012.fieldbyname('T$NAMB').Value;
          cdsCMS.FieldByName('NAMC').Value := T012.fieldbyname('T$NAMC').Value;
          cdsCMS.FieldByName('NAMD').Value := T012.fieldbyname('T$NAMD').Value;
          cdsCMS.FieldByName('NAME').Value := T012.fieldbyname('T$NAME').Value;
          cdsCMS.FieldByName('NAMF').Value := T012.fieldbyname('T$NAMF').Value;
          cdsCMS.FieldByName('CCTY').Value := T012.fieldbyname('T$CCTY').Value;
          cdsCMS.FieldByName('PSTC').Value := T012.fieldbyname('T$PSTC').Value;
          cdsCMS.POST;
          cdsCMS.ApplyUpdates;
          C029.FieldByName('BILL_CCTY').Value := T000.Fieldbyname('T$CCTY').Value;
        end;
      end
      else
        if CDS_Open(T000, '0SELECT * FROM TRITON.TTCCOM010' + Get000(IntToStr(Par_GRUP), 3)
                        + '  WHERE T$CUNO = '+ QuotedStr(Par_CUNO)) then
        begin
          cdsCMS.FieldByName('NAMA').Value := T000.fieldbyname('T$NAMA').Value;
          cdsCMS.FieldByName('NAMB').Value := T000.fieldbyname('T$NAMB').Value;
          cdsCMS.FieldByName('NAMC').Value := T000.fieldbyname('T$NAMC').Value;
          cdsCMS.FieldByName('NAMD').Value := T000.fieldbyname('T$NAMD').Value;
          cdsCMS.FieldByName('NAME').Value := T000.fieldbyname('T$NAME').Value;
          cdsCMS.FieldByName('NAMF').Value := T000.fieldbyname('T$NAMF').Value;
          cdsCMS.FieldByName('CCTY').Value := T000.fieldbyname('T$CCTY').Value;
          cdsCMS.FieldByName('PSTC').Value := T000.fieldbyname('T$PSTC').Value;
          cdsCMS.POST;
          cdsCMS.ApplyUpdates;
          C029.FieldByName('BILL_CCTY').Value := T000.Fieldbyname('T$CCTY').Value;
        end
        else
        begin
          Show_Memo_Line_Data(format('--> This PINO: %S '+ #13
                                   + '  Picking List Postal Adress '
                                   + '  (Ref. CMPPS083 Table)', [Par_PINO]));
          Abort;
        end;
          C029.Post;
          C029.ApplyUpdates;
    end;

    // insert cmpps084
    if not CDS_Open(cdsCMS, 'SELECT * FROM CMPPS084 '
                          + ' WHERE NCMP = '+ Par_NCMP
                          + '   AND ORNO = '+ Par_ORNO) then
    begin
      if CDS_Open(T000, '0SELECT * FROM TRITON.TTDSLS851' + Get000(Par_NCMP, 3)
                      + '  WHERE T$ORNO = '+ Par_ORNO) then
      begin
        while not T000.Eof do
        begin
          cdsCMS.Append;
          cdsCMS.FieldByName('NCMP').Value := Par_NCMP;
          cdsCMS.FieldByName('ORNO').Value := Par_ORNO;
          cdsCMS.FieldByName('CTYP').Value := Trim(T000.FieldByName('T$CTYP').Value);
          cdsCMS.FieldByName('NAME').Value := Trim(T000.FieldByName('T$NAME').Value);
          cdsCMS.FieldByName('IDCD').Value := Trim(T000.FieldByName('T$IDCD').Value);
          cdsCMS.FieldByName('NAMA').Value := Trim(T000.FieldByName('T$NAMA').Value);
          cdsCMS.FieldByName('NAMB').Value := Trim(T000.FieldByName('T$NAMB').Value);
          cdsCMS.FieldByName('ADDA').Value := Trim(T000.FieldByName('T$ADDA').Value);
          cdsCMS.FieldByName('ADDB').Value := Trim(T000.FieldByName('T$ADDB').Value);
          cdsCMS.FieldByName('CTYA').Value := Trim(T000.FieldByName('T$CTYA').Value);
          cdsCMS.FieldByName('CTYB').Value := Trim(T000.FieldByName('T$CTYB').Value);
          cdsCMS.FieldByName('PSTC').Value := Trim(T000.FieldByName('T$PSTC').Value);
          cdsCMS.FieldByName('CCTY').Value := Trim(T000.FieldByName('T$CCTY').Value);
          cdsCMS.FieldByName('STNO').Value := Trim(T000.FieldByName('T$STNO').Value);
          cdsCMS.FieldByName('DPNO').Value := Trim(T000.FieldByName('T$DPNO').Value);
          cdsCMS.FieldByName('CTNA').Value := Trim(T000.FieldByName('T$CTNA').Value);
          cdsCMS.FieldByName('CMNO').Value := Trim(T000.FieldByName('T$CMNO').Value);
          cdsCMS.FieldByName('ADDC').Value := Trim(T000.FieldByName('T$ADDC').Value);
          cdsCMS.FieldByName('ADDD').Value := Trim(T000.FieldByName('T$ADDD').Value);
          cdsCMS.Post;
          cdsCMS.ApplyUpdates;
          T000.next;
        end;
      end;
    end;
    // INSERT CMPPS085
    if not CDS_Open(cdsCMS, 'SELECT * FROM CMPPS085'
                          + ' WHERE NCMP = '+ Par_NCMP
                          + '   AND ORNO = '+ Par_ORNO) then
      if Session_Constraint('PPSM02S01', 'ORDER_MSG_SLS847') = 'Y' then
      begin
        if CDS_Open(T000, '0SELECT T$MESS,T$SEQN, T$INSN, T$ORNO,T$PONO '
                        + '   FROM TRITON.TTDSLS852' + Get000(Par_NCMP, 3)
                        + '  WHERE T$ORNO = '+ Par_ORNO) then
        while not T000.Eof do
        begin
          cdsCMS.Append;
          cdsCMS.FieldByName('NCMP').Value := Par_NCMP;
          cdsCMS.FieldByName('ORNO').Value := T000.FieldByName('T$ORNO').Value;
          cdsCMS.FieldByName('PONO').Value := T000.FieldByName('T$PONO').Value;
          cdsCMS.FieldByName('INSN').Value := T000.FieldByName('T$INSN').Value;
          cdsCMS.FieldByName('SEQN').Value := T000.FieldByName('T$SEQN').Value;
          cdsCMS.FieldByName('MESS').Value := T000.FieldByName('T$MESS').Value;
          cdsCMS.POST;
          cdsCMS.ApplyUpdates;
          T000.Next;
        end;
      end
      else if CDS_Open(T000, '0SELECT T$MESS, T$SEQN, T$ORNO, T$PONO '
                           + '   FROM TRITON.TTDSLS847' + Get000(Par_NCMP, 3)
                           + '  WHERE T$ORNO = '+ Par_ORNO) then
      while not T000.Eof do
      begin
        cdsCMS.Append;
        cdsCMS.FieldByName('NCMP').Value := Par_NCMP;
        cdsCMS.FieldByName('ORNO').Value := T000.FieldByName('T$ORNO').Value;
        cdsCMS.FieldByName('PONO').Value := T000.FieldByName('T$PONO').Value;
        cdsCMS.FieldByName('INSN').Value := T000.FieldByName('T$INSN').Value;
        cdsCMS.FieldByName('SEQN').Value := T000.FieldByName('T$SEQN').Value;
        cdsCMS.FieldByName('MESS').Value := T000.FieldByName('T$MESS').Value;
        cdsCMS.POST;
        cdsCMS.ApplyUpdates;
        T000.Next;
      end;

    if not CDS_Open(cdsCMS, 'SELECT * FROM CMPPS090 '
                          + '  WHERE NCMP = '+ Get000(Par_NCMP, 3)
                          + '    AND ITEM = '+ QuotedStr(Trim(strITEM))) then
    Begin
      if CDS_Open(T000, '0SELECT T001.T$ITEM, T001.T$DSCA, T902.T$GNDS, T001.T$CSEL, '
                      + '        T902.T$BCLA, T902.T$MCLA, T902.T$SCLA, T001.T$CTYO, '
                      + '        T902.T$BKFG, T902.T$MCNO, T902.T$UCCC, T902.T$RELE  '
                      + '   FROM TRITON.TTIITM001' + Get000(Par_NCMP, 3)+ ' T001,    '
                      + '        TRITON.TTIITM902' + Get000(Par_NCMP, 3)+ ' T902     '
                      + '  WHERE LTRIM(RTRIM(T001.T$ITEM)) = LTRIM(RTRIM(T902.T$ITEM))'
                      + '    AND LTRIM(RTRIM(T001.T$ITEM)) = '+ QuotedStr(Trim(strITEM))) then
      while Not T000.Eof do
      Begin
        If (TRIM(T000.FieldByName('T$ITEM').AsString) = '') And (Par_NCMP = ' ') then
          T000.Next
        Else
        Begin
          cdsCMS.Append ;
          cdsCMS.FieldByName('NCMP').Value := Par_NCMP;
          cdsCMS.FieldByName('ITEM').Value := Trim(T000.FieldByName('T$ITEM').Value);
          cdsCMS.FieldByName('DSCA').Value := T000.FieldByName('T$DSCA').Value;
          cdsCMS.FieldByName('GNDS').Value := T000.FieldByName('T$GNDS').Value;
          cdsCMS.FieldByName('CSEL').Value := T000.FieldByName('T$CSEL').Value;
          cdsCMS.FieldByName('BCLA').Value := T000.FieldByName('T$BCLA').Value;
          cdsCMS.FieldByName('MCLA').Value := T000.FieldByName('T$MCLA').Value;
          cdsCMS.FieldByName('SCLA').Value := T000.FieldByName('T$SCLA').Value;
          cdsCMS.FieldByName('CTYO').Value := T000.FieldByName('T$CTYO').Value;
          cdsCMS.FieldByName('BKFG').Value := T000.FieldByName('T$BKFG').Value;
          cdsCMS.FieldByName('MCNO').Value := T000.FieldByName('T$MCNO').Value;
          cdsCMS.FieldByName('UCCC').Value := T000.FieldByName('T$UCCC').Value;
          cdsCMS.FieldByName('RELE').Value := T000.FieldByName('T$RELE').Value;
          cdsCMS.Post ;
          cdsCMS.ApplyUpdates ;
          T000.Next ;
        End;
      End;
    End;

{   // INSERT CMPPS094 DATA
    if not Q_Open(C094, '0SELECT * FROM CMPPS094'
                      + '  WHERE NCMP = '+ Par_NCMP
                      + '    AND CUNO = '+ QuotedStr(CDS_CTmp.FieldByName('OCST').AsString)
                      + '    AND CCTY = '+ QuotedStr(C029.FieldByName('CCTY').AsString)) then
    Begin
      if Q_Open(T000, '0SELECT * FROM TRITON.TTDSLS853' + par_NCMP
                    + '  WHERE T$OCST = '+ QuotedStr(CDS_CTmp.FieldByName('OCST').AsString)
                    + '    AND T$SHIP = '+ QuotedStr(C029.FieldByName('CCTY').AsString)) then
      while not T000.Eof do
      Begin
        C094.Append;
        C094.FieldByName('NCMP').Value := Par_NCMP;
        C094.FieldByName('CUNO').Value := T000.FieldByName('T$OCST').Value;
        C094.FieldByName('CCTY').Value := T000.FieldByName('T$SHIP').Value;
        C094.FieldByName('CCUR').Value := T000.FieldByName('T$CCUR').Value;
        C094.FieldByName('SLTA').Value := T000.FieldByName('T$SLTA').Value;
        C094.FieldByName('SLTB').Value := T000.FieldByName('T$SLTB').Value;
        C094.FieldByName('SLTC').Value := T000.FieldByName('T$SLTC').Value;
        C094.FieldByName('SLTD').Value := T000.FieldByName('T$SLTD').Value;
        C094.FieldByName('SLTE').Value := T000.FieldByName('T$SLTE').Value;
        C094.FieldByName('SLBA').Value := T000.FieldByName('T$SLBA').Value;
        C094.FieldByName('SLBB').Value := T000.FieldByName('T$SLBB').Value;
        C094.FieldByName('SLBC').Value := T000.FieldByName('T$SLBC').Value;
        C094.FieldByName('SLBD').Value := T000.FieldByName('T$SLBD').Value;
        C094.FieldByName('SLBE').Value := T000.FieldByName('T$SLBE').Value;
        C094.FieldByName('TERM').Value := T000.FieldByName('T$TERM').Value;
        C094.FieldByName('CPAY').Value := T000.FieldByName('T$CPAY').Value;
        C094.POST;
        C094.ApplyUpdates;
        T000.Next ;
      End;
    End;
}    
  end;

  function ff_Compare_Picking: string;
  var
    fs_HCUNO, fs_CRTE, fs_MPAK, fs_CFRW, fs_File_DESADV, fs_CDEL, fs_CCTY: String;
    fs_CCOR, fs_BILL_CCTY, fs_NAMC, fs_NAMD, fs_NAME, fs_NAMF, fs_PSTC, fs_ALLOW_COMBINE: String;
    fn_COMBINE_TYPE: Integer;
    Receive_Keepdata: Array of String;
  begin
    if High(Receive_Keepdata) < 2 then Setlength(Receive_Keepdata, 3);
    if ISAME_ADD and C029.Active and C021.Active then
    begin
      if Receive_Keepdata[0] <> 'Y' then
      begin
        Receive_Keepdata[0] := 'Y';
        Receive_Keepdata[1] := C021.FieldbyName('NCMP').Asstring;
        Receive_Keepdata[2] := C021.FieldbyName('PINO').Asstring;
      end else
      begin
        Cds_Open(Cds_Tmp, '0SELECT C021.HCUNO HCUNO, C021.CRTE CRTE, C021.MPAK MPAK, C021.CFRW CFRW,            '
                        + '        C021.FILE_DESADV FILE_DESADV, C021.CDEL CDEL, C021.CCTY CCTY, C021.CCOR CCOR,'
                        + '        C021.BILL_CCTY BILL_CCTY, C021.NAMC NAMC, C021.NAMD NAMD, C021.NAME NAME,    '
                        + '        C021.NAMF NAMF, C021.PSTC PSTC,                                              '
                        + '        UPPER(NVL(C020.ALLOW_COMBINE, ''N'')) ALLOW_COMBINE,                         '
                        + '        NVL(C020.COMBINE_TYPE, 0) COMBINE_TYPE                                       '
                        + '   FROM CMPPS020 C020,                                                               '
                        + '       (SELECT C021.NCMP NCMP, C021.HCUNO HCUNO, C021.CRTE CRTE, C021.MPAK MPAK,     '
                        + '               C021.CFRW CFRW, C021.FILE_DESADV FILE_DESADV,                         '
                        + '               NVL(C029.CDEL, ''NVL'') CDEL, NVL(C029.CCTY, ''NVL'') CCTY,           '
                        + '               NVL(C029.CCOR, ''NVL'') CCOR, NVL(C029.BILL_CCTY, ''NVL'') BILL_CCTY, '
                        + '               NVL(C029.NAMC, ''NVL'') NAMC, NVL(C029.NAMD, ''NVL'') NAMD,           '
                        + '               NVL(C029.NAME, ''NVL'') NAME, NVL(C029.NAMF, ''NVL'') NAMF,           '
                        + '               NVL(C029.PSTC, ''NVL'') PSTC                                          '
                        + '          FROM CMPPS021 C021, CMPPS029 C029                                          '
                        + '         WHERE C021.NCMP = ' + IntToStr(Par_NCMP)
                        + '           AND C021.PINO IN (' + Receive_Keepdata[2] + ', ' + C021.FieldbyName('PINO').AsString + ')'
                        + '           AND C029.NCMP = C021.NCMP                                                 '
                        + '           AND C029.PINO = C021.PINO) C021                                           '
                        + '  WHERE C020.NCMP (+) = C021.NCMP                                                    '
                        + '    AND C020.CUNO (+) = C021.HCUNO                                                   '
                        + '    AND C020.CCTY (+) = C021.CCTY                                                    '
                        + '    AND C020.CFRW (+) = C021.CFRW');
            fs_HCUNO := Cds_Tmp.FieldbyName('HCUNO').AsString;
            fs_CRTE  := Cds_Tmp.FieldbyName('CRTE').AsString;
            fs_MPAK  := Cds_Tmp.FieldbyName('MPAK').AsString;
            fs_CFRW  := Cds_Tmp.FieldbyName('CFRW').AsString;
            fs_CDEL  := Cds_Tmp.FieldbyName('CDEL').AsString;
            fs_CCTY  := Cds_Tmp.FieldbyName('CCTY').AsString;
            fs_CCOR  := Cds_Tmp.FieldbyName('CCOR').AsString;
            fs_NAMC  := Cds_Tmp.FieldbyName('NAMC').AsString;
            fs_NAMD  := Cds_Tmp.FieldbyName('NAMD').AsString;
            fs_NAME  := Cds_Tmp.FieldbyName('NAME').AsString;
            fs_NAMF  := Cds_Tmp.FieldbyName('NAMF').AsString;
            fs_PSTC  := Cds_Tmp.FieldbyName('PSTC').AsString;
            fs_BILL_CCTY     := Cds_Tmp.FieldbyName('BILL_CCTY').AsString;
            fs_FILE_DESADV   := Cds_Tmp.FieldbyName('FILE_DESADV').AsString;
            fs_ALLOW_COMBINE := Cds_Tmp.FieldbyName('ALLOW_COMBINE').AsString;
            fn_COMBINE_TYPE  := Cds_Tmp.FieldbyName('COMBINE_TYPE').AsInteger;
            Cds_Tmp.Next;
            if fs_ALLOW_COMBINE <> 'Y' then
            begin
              Result := 'These Picking List Not Allowed Combined' + #13
                      + 'Please Maintain Combine Shipment Mechanism Data' + #13
                      + '(Ref. CMPPS020 Table)';
              exit;
            end;
              if fs_HCUNO <> Cds_Tmp.FieldbyName('HCUNO').AsString then
              begin
                 Result := 'These Picking List''s Customer Must be Same.';
                 exit;
              end;
              if fs_CRTE <> Cds_Tmp.FieldbyName('CRTE').AsString then
              begin
                Result := 'These Picking List''s Ship Way Must be same.';
                exit;
              end;
              if fs_MPAK <> Cds_Tmp.FieldbyName('MPAK').AsString then
              begin
                Result := 'These Picking List''s Packing Method Must be Same.';
                exit;
              end;
              if fs_CFRW <> Cds_Tmp.FieldbyName('CFRW').AsString then
              begin
                Result := 'These Picking List''s Forwarder Agent Must be Same.';
                exit;
              end;
              if fs_FILE_DESADV <> Cds_Tmp.FieldbyName('FILE_DESADV').AsString then
              begin
                Result := 'These Picking List''s had Generated EDI DesAdv.';
                exit;
              end;
              if fn_COMBINE_TYPE <> Cds_Tmp.FieldbyName('COMBINE_TYPE').AsInteger then
              begin
                Result := 'These Picking List''s [COMBINE_TYPE] Must be Same' + #13
                        + 'Please Maintain Combine Shipment Mechanism Data' + #13
                        + '(Ref. CMPPS020 Table)';
                exit;
              end;
            case fn_COMBINE_TYPE of
              1: begin // Combine by Address
                  if (fs_NAMC <> Cds_Tmp.FieldbyName('NAMC').AsString) or
                     (fs_NAMD <> Cds_Tmp.FieldbyName('NAMD').AsString) or
                     (fs_NAME <> Cds_Tmp.FieldbyName('NAME').AsString) or
                     (fs_NAMF <> Cds_Tmp.FieldbyName('NAMF').AsString) or
                     (fs_PSTC <> Cds_Tmp.FieldbyName('PSTC').AsString) then
                    begin
                      Result := 'These Picking List''s Delivery Address Must be Same.' + #13
                        + '(Ref. CMPPS029 Table)';
                      exit;
                    end;
                end;
              2: begin // Combine by Country
                  if (fs_CCTY <> Cds_Tmp.FieldbyName('CCTY').AsString) or
                    (fs_BILL_CCTY <> Cds_Tmp.FieldbyName('BILL_CCTY').AsString) then
                    begin
                      Result := 'These Picking List''s' + #13
                        + 'Delivery/Bill Country Must be Same.'
                        + '(Ref. CMPPS029 Table)';
                      exit;
                    end; Get000(IntToStr(Par_NCMP), 3)
                end;
              3: begin // Combine by EU Country Group
                  Cds_Open(Cds_TTmp, '0Select count(*) SAME_COUNTRY_GROUP                   '
                    + '   From TRITON.TTCMCS010' + Get000(IntToStr(Par_GRUP), 3) + ' A,'
                    + '        TRITON.TTCMCS010' + Get000(IntToStr(Par_GRUP), 3) + ' B '
                    + '  Where A.t$CCTY = ' + QuotedStr(fs_CCTY)
                    + '    And B.t$CCTY = ' + QuotedStr(Cds_Tmp.FieldbyName('CCTY').AsString)
                    + '    And A.t$MEEC = B.t$MEEC');
                  if Cds_TTmp.FieldbyName('SAME_COUNTRY_GROUP').AsInteger = 0 then
                    begin
                      Result := 'These Picking List''s Country' + #13
                        + 'Should Belong to Same EU Country Group.'
                        + '(Ref. CMPPS020 Table)';
                      exit;
                    end;
                end;
            end;
          end;
      end;
    Result := 'Success';
  end;
  function GetLine(var MultiLines: Variant; N: integer): string;
  begin
    Result := '';
    if N <= VararrayHighBound(MultiLines, 1) then Result := MultiLines[N];
  end;
begin
  result := '';
  EPS_prepare := false;
  MPAK := '';
  Par_PTYP := '';
  Par_CFRW := '';
  C002 := Create_Cds('CMS', nil);
  C021 := Create_Cds('CMS', nil);
  C022 := Create_Cds('CMS', nil);
  C029 := Create_Cds('CMS', nil);
  C062 := Create_Cds('CMS', nil);
  C066 := Create_Cds('CMS', nil);
  C067 := Create_Cds('CMS', nil);
  C071 := Create_Cds('CMS', nil);
  C101 := Create_Cds('CMS', nil);
  T012 := Create_Cds('TRITON', nil);
  T000 := Create_Cds('TRITON', nil);
  cdsCMS   := Create_Cds('CMS', nil);
  CDS_CTmp := Create_Cds('CMS', nil);
  CDS_Tmp  := Create_Cds('CMS', nil);
  Cds_CSav := Create_Cds('CMS', nil);
  Cds_TTmp := Create_Cds('TRITON', nil);
  try
    try
      DBCMS.Connected := True;
      if not dbCMS.InTransaction then dbCMS.StartTransaction;
      Cds_Open(Cds_CTmp, '0SELECT DISTINCT NCMP, GNMP, PINO, ORNO, CWAR, INVD, COTP, CORG, CRTE, CFRW,  '
                       + '                 REFA, CUNO, CDEL, CCOR, TTYP, INVN, PKCD, OCST, STATUS, MITO,'
                       + '                 ODAT, CREP, CCUR, APAR, OMCU, PRIC, INST, PTYP               '
                       + '   FROM RECEIVEPICKING                                                        '
                       + '  WHERE QUEU   = 1                                                            '
                       + '    AND STATUS = 0                                                            '
                       + '  ORDER BY NCMP, PINO, ORNO');

      {       Cds_Open(Cds_CTmp, '0SELECT DISTINCT NCMP, GNMP, PINO, ORNO, CWAR, INVD, COTP, CORG, CRTE, CFRW, '
                              + '                 REFA, CUNO, CDEL, CCOR, TTYP, INVN, PKCD, OCST, STATUS      '
                              + '   FROM RECEIVEPICKING                                                       '
                              + '  WHERE PINO   = '+ QuotedStr('2307')
                              + '    AND STATUS = 0                                                           '
                              + '  ORDER BY NCMP, PINO, ORNO');
      }
      while not CDS_CTmp.Eof do
      begin
        if CDS_CTmp.Fieldbyname('PKCD').Asstring = '2' then MPAK := 'CTN'
        else MPAK := 'PLT';

        Par_NCMP := Cds_CTmp.Fieldbyname('NCMP').AsInteger;
        Par_PINO := Cds_CTmp.Fieldbyname('PINO').AsInteger;
        Par_GRUP := Cds_CTmp.Fieldbyname('GNMP').AsInteger;
        Par_ORNO := Cds_CTmp.Fieldbyname('ORNO').AsInteger;
        Par_CUNO := Cds_CTmp.Fieldbyname('CUNO').AsString;
        Par_CCOR := Cds_CTmp.Fieldbyname('CCOR').AsString;
        Par_PTYP := Cds_CTmp.Fieldbyname('PTYP').AsString;
        if MPAK = 'CTN' then Par_USER := 'ctn' + Cds_CTmp.Fieldbyname('NCMP').asstring
        else if MPAK = 'PLT' then Par_USER := 'plt' + Cds_CTmp.Fieldbyname('NCMP').asstring;

        if (MPAK = 'CTN') or (MPAK = 'BOX') then
        begin
          VarClear(Lines);
          StrtoVariant(Session_Constraint('ALLSESID', 'EPS_PACLST_PREPARE'), Lines, '|');
          if mEPSflag and hasinLines(Lines, Par_PTYP) then
          begin
            EPS_Prepare := True;
          end;
        end;

        if hasinLines(Session_Constraint('ALLSESID', 'CHECK_FORWARDER_CODE'), Cds_CTmp.FieldByName('CUNO').Asstring)
        and (Cds_CTmp.FieldByName('CFRW').Asstring = '') then
        begin
          Par_DSCA := 'Picking No: ' + IntToStr(Par_PINO) + ' without Forwarding Agent in TRITON !';
          DBCMS.Rollback;
          Update_Error_Log(Par_NCMP, Par_PINO, Par_CUNO, Par_DSCA);
          Par_DSCA := '';
          Cds_CTmp.Next; Continue;
        end
        else if Cds_CTmp.FieldByName('CFRW').Asstring <> '' then
        begin
          if Cds_Open(Cds_Tmp, '0SELECT EPS_CFRW FROM CMPPS007  '
                             + '  WHERE CFRW = '+ QuotedStr(Cds_CTmp.FieldByName('CFRW').AsString)) then
            Par_CFRW := Cds_Tmp.Fieldbyname('EPS_CFRW').AsString;
        end;

        // 980 Always Ready !
        if not HasinLines(Session_Constraint('PPSM02S01', 'PPS_RECEIVE_PROCESSTYPE'), Par_PTYP) then
        begin
          Result := 'This Order doesn''t belong to PPS !';
          Show_Memo_Line_Data(Format('--> This Order : %s ',
                             [IntToStr(Par_NCMP) + ' / ' + IntToStr(Par_PINO) + ' doesn''t belong to PPS !']));
          Abort;
        end;

        //--------------update cmpps021-------//
        if Cds_Open(C021, 'SELECT * FROM CMPPS021'
                        + ' WHERE NCMP = '+ IntToStr(Par_NCMP)
                        + '   AND PINO = '+ IntToStr(Par_PINO)) then
        begin
          if (Par_PTYP <> '') and C021.Locate('RUNID', Par_PTYP, []) then
          begin
            if C021.FieldByName('STATUS').Asinteger = 8 then
              DoUPdateCMPPS021
            else
            begin
              Par_DSCA := 'Picking No: ' + IntToStr(Par_PINO) + ' belong to another Accumulate Order!';
              Show_Memo_Line_Data(format('--> %s belong to another Accumulate Order!',
                                 [IntToStr(Par_NCMP) + ' / ' + IntToStr(Par_PINO)]));
              Prepare_Set_Status(Par_NCMP, par_PINO);
              Update_Error_Log(Par_NCMP, Par_PINO, Par_CUNO, Par_DSCA);
              DBCMS.Commit;
              Cds_CTmp.Next; Continue;
            end;
          end else
          begin
            C021.First;
            if C021.FieldByName('STATUS').Asinteger = 8 then
              DoUPdateCMPPS021
            else
            begin
              Par_DSCA := 'Picking No: ' + IntToStr(Par_PINO) + ' belong to another Accumulate Order!';
              Show_Memo_Line_Data(format('--> %s belong to another Accumulate Order!',
                                 [IntToStr(Par_NCMP) + ' / ' + IntToStr(Par_PINO)]));
              Prepare_Set_Status(Par_NCMP, par_PINO);
              Update_Error_Log(Par_NCMP, Par_PINO, Par_CUNO, Par_DSCA);
              DBCMS.Commit;
              Cds_CTmp.Next; Continue;
            end;
          end;
        end else
        begin
        //------------------------ Insert cmpps021
          C021.Append;
          C021.FieldByName('NCMP').Asstring := IntToStr(Par_NCMP);
          C021.FieldByName('PINO').Asstring := IntToStr(Par_PINO);
          DoUPdateCMPPS021;
        end;
        //-----------------CMPPS021 UPdate Finished_1
        if Cds_Open(C101, '0SELECT SESID FROM CMPPS101 '
                        + '  WHERE RUNID   = '+ QuotedStr(Par_PTYP)
                        + '    AND AOPTION = 1         '
                        + '    AND COMPID  = '+ IntToStr(Par_NCMP)) then
        begin
          C101.First;
          C021.Edit;
          C021.FieldByName('RUNSES').Asstring := C101.FieldByName('SESID').Asstring;
          While not C101.EOF do
          begin
            Q_Execute(cdsCMS, 'INSERT INTO CMPPS104 (COMPID, PINO, SESID, STATUS) '
                            + 'VALUES (' + IntToStr(Par_NCMP) + ',  '
                            + IntToStr(Par_PINO) + ',  '
                            + QuotedStr(C101.Fieldbyname('SESID').Asstring) + ','
                            + '9)');
            C101.Next;
          end;
        end;
          C101.Close;
          //----------------------------Insert data to CMPPS029--------------------//
          if not Cds_Open(C029, 'SELECT * FROM CMPPS029 '
                              + ' WHERE NCMP = '+ IntToStr(Par_NCMP)
                              + '   AND PINO = '+ IntToStr(Par_PINO)) then
          begin
            C029.Append;
            C029.FieldByName('NCMP').Asinteger := Par_NCMP;
            C029.FieldByName('PINO').Asinteger := Par_PINO;
            if Cds_Open(T000, '0SELECT * FROM TRITON.TTDSLS042' + Get000(IntToStr(Par_NCMP), 3)
                            + '  WHERE T$ORNO = '+ Cds_CTmp.Fieldbyname('ORNO').Asstring
                            + '    AND T$CKOR = 0') then
            begin
              C029.FieldByName('NAMA').Value := T000.Fieldbyname('T$NAMA').Value;
              C029.FieldByName('NAMB').Value := T000.Fieldbyname('T$NAMB').Value;
              C029.FieldByName('NAMC').Value := T000.Fieldbyname('T$NAMC').Value;
              C029.FieldByName('NAMD').Value := T000.Fieldbyname('T$NAMD').Value;
              C029.FieldByName('NAME').Value := T000.Fieldbyname('T$NAME').Value;
              C029.FieldByName('NAMF').Value := T000.Fieldbyname('T$NAMF').Value;
              C029.FieldByName('CCTY').Value := T000.Fieldbyname('T$CCTY').Value;
              C029.FieldByName('PSTC').Value := T000.Fieldbyname('T$PSTC').Value;
            end else
            begin
              if Cds_CTmp.Fieldbyname('CDEL').Asstring <> '' then
              begin
                if Cds_Open(T000, '0SELECT * FROM TRITON.TTCCOM013' + Get000(IntToStr(Par_NCMP), 3)
                                + '  WHERE T$CUNO = '+ QuotedStr(Cds_CTmp.Fieldbyname('CUNO').Asstring)
                                + '    AND T$CDEL = '+ QuotedStr(Cds_CTmp.Fieldbyname('CDEL').Asstring)) then
                begin
                  C029.FieldByName('NAMA').Value := T000.Fieldbyname('T$NAMA').Value;
                  C029.FieldByName('NAMB').Value := T000.Fieldbyname('T$NAMB').Value;
                  C029.FieldByName('NAMC').Value := T000.Fieldbyname('T$NAMC').Value;
                  C029.FieldByName('NAMD').Value := T000.Fieldbyname('T$NAMD').Value;
                  C029.FieldByName('NAME').Value := T000.Fieldbyname('T$NAME').Value;
                  C029.FieldByName('NAMF').Value := T000.Fieldbyname('T$NAMF').Value;
                  C029.FieldByName('CCTY').Value := T000.Fieldbyname('T$CCTY').Value;
                  C029.FieldByName('PSTC').Value := T000.Fieldbyname('T$PSTC').Value;
                  C029.FieldByName('CDEL').Value := T000.Fieldbyname('T$CDEL').Value;
                end;
              end else
              begin
                if Cds_Open(T000, '0SELECT * FROM TRITON.TTCCOM010' + Get000(IntToStr(Par_GRUP), 3)
                                + '  WHERE T$CUNO = '+ QuotedStr(Cds_CTmp.Fieldbyname('CUNO').Asstring)) then
                begin
                  C029.FieldByName('NAMA').Value := T000.Fieldbyname('T$NAMA').Value;
                  C029.FieldByName('NAMB').Value := T000.Fieldbyname('T$NAMB').Value;
                  C029.FieldByName('NAMC').Value := T000.Fieldbyname('T$NAMC').Value;
                  C029.FieldByName('NAMD').Value := T000.Fieldbyname('T$NAMD').Value;
                  C029.FieldByName('NAME').Value := T000.Fieldbyname('T$NAME').Value;
                  C029.FieldByName('NAMF').Value := T000.Fieldbyname('T$NAMF').Value;
                  C029.FieldByName('CCTY').Value := T000.Fieldbyname('T$CCTY').Value;
                  C029.FieldByName('PSTC').Value := T000.Fieldbyname('T$PSTC').Value;
                end;
              end;
            end;
              C029.FieldByName('CCOR').Value := Cds_CTmp.Fieldbyname('CCOR').Asstring;

              // ---CMPPS029 UPdate Finished_
              strbuf := StringReplace(C029.FieldByName('PSTC').AsString, ' ', '', [rfReplaceAll]);
              if (C029.FieldByName('CCTY').Asstring = '431') then
                C029.FieldByName('PSTC').AsString := Copy(strbuf, 1, 5)
              else if (C029.FieldByName('CCTY').Asstring = '401') then
                C029.FieldByName('PSTC').AsString := Copy(strbuf, 1, 6);
              if EPS_Prepare and (C029.FieldByName('NAMF').Asstring = '') and
                ((C029.FieldByName('CCTY').Asstring = '401') or (C029.FieldByName('CCTY').Asstring = '431')) then
              begin
                Result := 'State Code can''t be null.';
                Show_Memo_Line_Data(format('--> %s State Code can''t be null.',
                                   [IntToStr(Par_NCMP) + ' / ' + IntToStr(Par_PINO)]));
                Abort;
              end;
             // C029.Post;
             // C029.ApplyUpdates;
            end; //end Not found cmpps029

          // ---CMPPS021 UPdate Finished_2
          C021.Post;
          C021.ApplyUpdates;

          //------------------------insert data to cmpps071-------------------//
          if Q_Open(T000, '0SELECT T$ORNO, T$CSTN, T$DREQ, T$DTEL, T$ENMA, T$ENMB, T$CDCI, T$CSCD, '
                        + '        T$SMCO, T$MENO, T$TSTP, T$COOR, T$CPOD, T$SBID, T$CPON, T$CSON, '
                        + '        TO_CHAR(T$CPOD, ' + '''yyyymmdd'') T$CPODYEAR,                  '
                        + '        TO_CHAR(SYSDATE+730, ' + '''yyyymmdd'') T$SYSYEAR,              '
                        + '        T$DPER, T$SORN, T$WEBO, T$CUNO, T$QOTE, T$EADA, T$EADB, T$EADC, '
                        + '        T$EADD, T$EADE, T$ECTA, T$ECTB, T$ECTY, T$EZIP, T$POSC, T$REFA, '
                        + '        T$REFB, T$REFC, T$BLNO, T$PBNO, T$GSCD, T$OINF, T$FRTM, T$PLNT, '
                        + '        T$SGEO, T$DTYP, T$TTSD, T$POTC, T$ODMC, T$ODMN, T$RINS, T$DCOD  '
                        + '   FROM TRITON.TTDSLS940' + Get000(IntToStr(Par_NCMP), 3)
                        + '  WHERE T$ORNO = '+ IntToStr(Par_ORNO)) then
          begin
            if Q_Open(C071, 'SELECT * FROM CMPPS071'
                          + ' Where NCMP = '+ IntToStr(Par_NCMP)
                          + '   AND ORNO = '+ IntToStr(Par_ORNO)) then
              C071.Edit
            else C071.Append;
                 C071.FieldByName('NCMP').AsInteger := Par_NCMP;
                 C071.FieldByName('ORNO').Value := T000.fieldbyname('T$ORNO').Value;
                 C071.FieldByName('CSTN').Value := T000.fieldbyname('T$CSTN').Value;
                 C071.FieldByName('DREQ').Value := T000.fieldbyname('T$DREQ').Value;
                 C071.FieldByName('DTEL').Value := T000.fieldbyname('T$DTEL').Value;
                 C071.FieldByName('ENMA').Value := T000.fieldbyname('T$ENMA').Value;
                 C071.FieldByName('ENMB').Value := T000.fieldbyname('T$ENMB').Value;
                 C071.FieldByName('CDCI').Value := T000.fieldbyname('T$CDCI').Value;
                 C071.FieldByName('CSCD').Value := T000.fieldbyname('T$CSCD').Value;
                 C071.FieldByName('SMCO').Value := T000.fieldbyname('T$SMCO').Value;
                 C071.FieldByName('MENO').Value := T000.fieldbyname('T$MENO').Value;
                 C071.FieldByName('TSTP').Value := T000.fieldbyname('T$TSTP').Value;
                 C071.FieldByName('SBID').Value := T000.fieldbyname('T$SBID').Value;
                 C071.FieldByName('CPON').Value := T000.fieldbyname('T$CPON').Value;
                 C071.FieldByName('CSON').Value := T000.fieldbyname('T$CSON').Value;
                 C071.FieldByName('DPER').Value := T000.fieldbyname('T$DPER').Value;
                 C071.FieldByName('SORN').Value := T000.fieldbyname('T$SORN').Value;
                 C071.FieldByName('WEBO').Value := T000.fieldbyname('T$WEBO').Value;
                 C071.FieldByName('CUNO').Value := T000.fieldbyname('T$CUNO').Value;
                 C071.FieldByName('QOTE').Value := T000.fieldbyname('T$QOTE').Value;
                 C071.FieldByName('EADA').Value := T000.fieldbyname('T$EADA').Value;
                 C071.FieldByName('EADB').Value := T000.fieldbyname('T$EADB').Value;
                 C071.FieldByName('EADC').Value := T000.fieldbyname('T$EADC').Value;
                 C071.FieldByName('EADD').Value := T000.fieldbyname('T$EADD').Value;
                 C071.FieldByName('EADE').Value := T000.fieldbyname('T$EADE').Value;
                 C071.FieldByName('ECTA').Value := T000.fieldbyname('T$ECTA').Value;
                 C071.FieldByName('ECTB').Value := T000.fieldbyname('T$ECTB').Value;
                 C071.FieldByName('ECTY').Value := T000.fieldbyname('T$ECTY').Value;
                 C071.FieldByName('EZIP').Value := T000.fieldbyname('T$EZIP').Value;
                 C071.FieldByName('POSC').Value := T000.fieldbyname('T$POSC').Value;
                 C071.FieldByName('REFA').Value := T000.fieldbyname('T$REFA').Value;
                 C071.FieldByName('REFB').Value := T000.fieldbyname('T$REFB').Value;
                 C071.FieldByName('REFC').Value := T000.fieldbyname('T$REFC').Value;
                 C071.FieldByName('BLNO').Value := T000.fieldbyname('T$BLNO').Value;
                 C071.FieldByName('PBNO').Value := T000.fieldbyname('T$PBNO').Value;
                 C071.FieldByName('GSCD').Value := T000.fieldbyname('T$GSCD').Value;
                 C071.FieldByName('OINF').Value := T000.fieldbyname('T$OINF').Value;
                 C071.FieldByName('FRTM').Value := T000.fieldbyname('T$FRTM').Value;
                 C071.FieldByName('PLNT').Value := T000.fieldbyname('T$PLNT').Value;
                 C071.FieldByName('SGEO').Value := T000.fieldbyname('T$SGEO').Value;
                 C071.FieldByName('DTYP').Value := T000.fieldbyname('T$DTYP').Value;
                 C071.FieldByName('TTSD').Value := T000.fieldbyname('T$TTSD').Value;
                 C071.FieldByName('POTC').Value := T000.fieldbyname('T$POTC').Value;
                 C071.FieldByName('ODMC').Value := T000.fieldbyname('T$ODMC').Value;
                 C071.FieldByName('ODMN').Value := T000.fieldbyname('T$ODMN').Value;
                 C071.FieldByName('RINS').Value := T000.fieldbyname('T$RINS').Value;
                 C071.FieldByName('DCOD').Value := T000.fieldbyname('T$DCOD').Value;
                 C071.FieldByName('MITO').Value := Cds_CTmp.fieldbyname('MITO').Value;
                 C071.FieldByName('ODAT').Value := Cds_CTmp.fieldbyname('ODAT').Value;
                 C071.FieldByName('CREP').Value := Cds_CTmp.fieldbyname('CREP').Value;
                 C071.FieldByName('CCOR').Value := Cds_CTmp.fieldbyname('CCOR').Value;
                 C071.FieldByName('CDEL').Value := Cds_CTmp.fieldbyname('CDEL').Value;
                 C071.FieldByName('CCUR').Value := Cds_CTmp.fieldbyname('CCUR').Value;
                 C071.FieldByName('APAR').Value := Cds_CTmp.fieldbyname('APAR').Value;
                 if (T000.Fieldbyname('T$CPODYEAR').Asstring < '18991229') or
                    (T000.Fieldbyname('T$CPODYEAR').Asstring > T000.Fieldbyname('T$SYSYEAR').Asstring) then
                   C071.FieldByName('CPOD').Asstring := Check_invalidDate(StrToDateTime('1899/12/29'))
                 else
                   C071.FieldByName('CPOD').Asstring := Check_invalidDate(T000.Fieldbyname('T$CPOD').Asdatetime);
                   C071.FieldByName('COOR').Value := T000.Fieldbyname('T$COOR').Value;

                 if Q_Open(T000, '0Select T$RRDT, T$RETM '
                               + '  FROM TRITON.TTDSLS991' + Get000(IntToStr(Par_NCMP), 3)
                               + '  WHERE T$ORNO = '+ IntToStr(Par_ORNO)) then
                   C071.FieldByName('RRDT').Value := FormatDateTime('YYYY/MM/DD HH:MM',
                                            StrToDateTime(copy(T000.FieldByName('T$RRDT').AsString
                                                             + T000.FieldByName('T$RETM').AsString, 1, 4) + '/' +
                                                          copy(T000.FieldByName('T$RRDT').AsString
                                                             + T000.FieldByName('T$RETM').AsString, 5, 2) + '/' +
                                                          copy(T000.FieldByName('T$RRDT').AsString
                                                             + T000.FieldByName('T$RETM').AsString, 7, 2)+ '/' + ' ' +
                                                          copy(T000.FieldByName('T$RRDT').AsString
                                                             + T000.FieldByName('T$RETM').AsString, 9, 2)+ ':' +
                                                          copy(T000.FieldByName('T$RRDT').AsString
                                                             + T000.FieldByName('T$RETM').AsString, 11, 2)));
                   // --- CMPPS071 UPdate Finished
                   C071.POST;
                   C071.ApplyUpdates;
          end;
          //--------------------------Insert data to CMPPS062
          if Cds_Open(T000, '0SELECT T$ORNO, T$PONO, T$ITEM, T$GPID, T$GPTP, T$PDNO, T$OQUA, T$FPMQ, T$INVQ '
                          + '   FROM TRITON.TTDSLS911' + Get000(IntToStr(Par_NCMP), 3)
                          + '  WHERE T$ORNO = '+ Cds_CTmp.Fieldbyname('ORNO').Asstring
                          + '    AND T$PDNO <> 0') then
          begin
            while not T000.EOF do
            begin
              if not Cds_Open(C062, 'SELECT * FROM CMPPS062 '
                                  + ' WHERE NCMP = '+ IntToStr(Par_NCMP)
                                  + '   AND ORNO = '+ Cds_CTmp.Fieldbyname('ORNO').Asstring
                                  + '   AND PONO = '+ T000.Fieldbyname('T$GPID').Asstring) then
              begin
                C062.Append;
                C062.FieldByName('NCMP').AsInteger := Par_NCMP;
                C062.FieldByName('ORNO').Value := Cds_CTmp.Fieldbyname('ORNO').Asstring;
                C062.FieldByName('PONO').Value := T000.Fieldbyname('T$GPID').Asstring;
                C062.FieldByName('PDNO').Value := T000.FieldByName('T$PDNO').Value;
                C062.FieldByName('ITEM').Value := Trim(T000.Fieldbyname('T$ITEM').Asstring);
                C062.FieldByName('GPID').Value := T000.FieldByName('T$GPID').Value;
                C062.FieldByName('GPTP').Value := T000.FieldByName('T$GPTP').Value;
                C062.FieldByName('OQUA').Value := T000.Fieldbyname('T$OQUA').Asstring;
                C062.FieldByName('FPMQ').Value := T000.FieldByName('T$FPMQ').Value;
                C062.FieldByName('INVQ').Value := T000.FieldByName('T$INVQ').Value;
                C062.FieldByName('QFPM').Value := 0;
                C062.FieldByName('QINV').Value := 0;
                C062.POST;
                C062.ApplyUPDATES;
              end;
                T000.Next;
            end;
          end;

          //----------------------Insert Data to CMPPS066------------------//
          if Cds_Open(T000, '0SELECT T$ORNO, T$PSNO, T$ITEM, T$SESQ, T$SERL'
                          + '   FROM TRITON.TTDSLS850' + Get000(IntToStr(Par_NCMP), 3)
                          + '  WHERE T$ORNO = '+ Cds_CTmp.Fieldbyname('ORNO').Asstring) then
          begin
            while not T000.Eof do
            begin
              if not Cds_Open(C066, 'SELECT * FROM CMPPS066 '
                                  + ' WHERE NCMP = '+ IntToStr(Par_NCMP)
                                  + '   AND ORNO = '+ Cds_CTmp.Fieldbyname('ORNO').Asstring
                                  + '   AND PONO = '+ T000.Fieldbyname('T$PSNO').Asstring
                                  + '   AND SERL = '+ QuotedStr(T000.FieldByName('T$SERL').AsString)) then
                C066.Append
              else C066.Edit;
                   C066.FieldByName('NCMP').AsInteger := Par_NCMP;
                   C066.FieldByName('ORNO').Value := Cds_CTmp.Fieldbyname('ORNO').Asstring;
                   C066.FieldByName('PONO').Value := T000.Fieldbyname('T$PSNO').Asstring;
                   C066.FieldByName('ITEM').Value := Trim(T000.Fieldbyname('T$ITEM').Asstring);
                   C066.FieldByName('SESQ').Value := T000.FieldByName('T$SESQ').Value;
                   C066.FieldByName('SERL').Value := T000.FieldByName('T$SERL').Value;
                   C066.POST;
                   C066.ApplyUPDATEs;
                   T000.Next;
            end;
          end;

          //--------------------------insert data to cmpps022----------------------//
          Cds_Open(CDS_Tmp, '0SELECT NCMP, GNMP, PINO, ORNO, PONO, SRNB, OQUA, CWAR, ITEM, INVD, CUNO '
                          + '   FROM RECEIVEPICKING                                                   '
                          + '  WHERE NCMP   = ' + IntToStr(Par_NCMP)
                          + '    AND PINO   = ' + IntToStr(Par_PINO)
                          + '    AND QUEU   = 1                                                       '
                          + '    AND STATUS = 0                                                       '
                          + '  ORDER BY NCMP, PINO, PONO, SRNB ');
          CDS_Tmp.First;
          while not CDS_Tmp.EOF do
          begin
            if (not Cds_Open(C022, 'SELECT * FROM CMPPS022'
                                 + ' WHERE NCMP = '+ IntToStr(Par_NCMP)
                                 + '   AND PINO = '+ IntToStr(CDS_Tmp.Fieldbyname('PINO').Asinteger)
                                 + '   AND PONO = '+ IntToStr(CDS_Tmp.Fieldbyname('PONO').Asinteger)))
            and (Cds_Tmp.Fieldbyname('OQUA').Asinteger > 0) then
            begin
              C022.Append;
              C022.FieldByName('NCMP').Asinteger := Par_NCMP;
              C022.FieldByName('PINO').Value := par_PINO;
              C022.FieldByName('PONO').Value := CDS_Tmp.Fieldbyname('PONO').AsString;
              C022.FieldByName('CWAR').Value := CDS_Tmp.Fieldbyname('CWAR').AsString;
              C022.FieldByName('OQUA').Value := CDS_Tmp.Fieldbyname('OQUA').AsString;
              C022.FieldByName('ITEM').Value := Trim(CDS_Tmp.Fieldbyname('ITEM').AsString);
              C022.FieldByName('SRNB').Value := CDS_Tmp.Fieldbyname('SRNB').AsString;
              C022.FieldByName('PRIC').Value := Cds_CTmp.FieldByName('PRIC').AsFloat;
              if Check_invalidDate(Cds_Tmp.Fieldbyname('INVD').AsDateTime) = '1899/12/30' then
                C022.FieldByName('INVD').asstring := ''
              else C022.FieldByName('INVD').asstring := Check_invalidDate(Cds_Tmp.Fieldbyname('INVD').AsDateTime);
                C022.FieldByName('BAR_CHECK').Asstring := 'N';
                if Cds_Open(T000, '0SELECT T001.T$DSCA, T001.T$CSEL, T902.T$BCLA,                             '
                                + '        DECODE(T930.T$CINU, NULL, '' '', T930.T$CINU) T$CINU                '
                                + '   FROM TRITON.TTIITM001' + Get000(IntToStr(Par_NCMP), 3) + ' T001,        '
                                + '        TRITON.TTIITM902' + Get000(IntToStr(Par_NCMP), 3) + ' T902,        '
                                + '        TRITON.TTDSLS930' + Get000(IntToStr(Par_NCMP), 3) + ' T930         '
                                + '  WHERE T001.T$ITEM    = '+ QuotedStr(Cds_Tmp.Fieldbyname('ITEM').Asstring)
                                + '    AND T001.T$ITEM    = T902.T$ITEM                                       '
                                + '    AND T930.T$CUNO(+) = '+ QuotedStr(Par_CUNO)
                                + '    AND T930.T$ITEM(+) = T001.T$ITEM ') then
                begin
                  C022.FieldByName('DSCA').Value := T000.Fieldbyname('T$DSCA').Value;
                  C022.FieldByName('BCLA').Value := T000.Fieldbyname('T$BCLA').Value;
                  C022.FieldByName('HNUM').Asstring := Par_USER;
                  C022.FieldByName('CINU').Value := TRIM(T000.FieldByName('T$CINU').Value);
                  T_CSEL := T000.Fieldbyname('T$CSEL').Asstring;
                  if (T_CSEL <> '') and
                    Cds_Open(T000, '0SELECT T$CSEL     '
                                 + '   FROM TRITON.TTDRMA901' + Get000(IntToStr(Par_NCMP), 3)
                                 + '  WHERE T$CSEL = '+ QuotedStr(T_CSEL)
                                 + '    AND T$SRNO = 1 '
                                 + '    AND T$LRMA = '+ QuotedStr('1')) then
                    C022.FieldByName('BAR_CHECK').Asstring := 'Y';
                end;

                if Cds_Open(T000, '0SELECT * FROM TRITON.TTDSLS041' + Get000(IntToStr(Par_NCMP), 3)
                                + '  Where T$ORNO = '+ Cds_Tmp.Fieldbyname('ORNO').Asstring
                                + '    AND T$PONO = '+ Cds_Tmp.Fieldbyname('PONO').Asstring) then
                begin
                  C022.FieldByName('DQUA').Asinteger := 0;
                  C022.FieldByName('CUQS').Value := T000.Fieldbyname('T$CUQS').Value;
                  C022.FieldByName('DDTA').Value := T000.Fieldbyname('T$DDTA').Value;
                  C022.FieldByName('PORD').Value := T000.Fieldbyname('T$PORD').Value;
                  C022.FieldByName('DGFG').Value := T000.Fieldbyname('T$DGFG').Value;
                  C022.FieldByName('USGF').Value := T000.Fieldbyname('T$USGF').Value;
                  Par_DDTA := T000.FieldByName('T$DDTA').Value;
                  Par_APAR := T000.FieldByName('T$APAR').Value;
                end;
                  if not Cds_Open(cdsCMS, 'SELECT * FROM CMPPS081 '
                                        + ' WHERE NCMP = '+ IntToStr(Par_NCMP)
                                        + '   AND ORNO = '+ IntToStr(Par_ORNO)
                                        + '   AND PONO = '+ QuotedStr(Cds_Tmp.Fieldbyname('PONO').Asstring)) then
                  begin
                    if Cds_Open(T000, '0SELECT T941.T$ITEM, T941.T$REFD, T941.T$REFC, T941.T$CPON, '
                                    + '        T941.T$CPRT, T941.T$CUMN, T941.T$CITM, T941.T$CUIT, '
                                    + '        T941.T$TREF, T941.T$COPO, T941.T$CSOL, T941.T$SOLN, '
                                    + '        T941.T$SLCD, T941.T$UPCC, T941.T$DELG, T941.T$SOSL, '
                                    + '        T941.T$SCIP, T705.T$REFN, T981.T$CODT,              '
                                    + '        TO_DATE(DECODE(TO_CHAR(T941.T$RQDT,''YYYY/MM/DD''),''9999/01/01'',NULL,TO_CHAR(T941.T$RQDT,''YYYY/MM/DD'')),''YYYY/MM/DD'') T$RQDT '
                                    + '   FROM TRITON.TTDSLS941' + Get000(IntToStr(Par_NCMP), 3) + ' T941,   '
                                    + '        TRITON.TTDSLS981' + Get000(IntToStr(Par_NCMP), 3) + ' T981,   '
                                    + '        TRITON.TTCEDI705' + Get000(IntToStr(Par_NCMP), 3) + ' T705    '
                                    + '  WHERE T941.T$ORNO = '+ Cds_Tmp.Fieldbyname('ORNO').Asstring
                                    + '    AND T941.T$PONO = '+ Cds_Tmp.Fieldbyname('PONO').Asstring
                                    + '    AND T941.T$ORNO = T705.T$ORNO                           '
                                    + '    AND T941.T$ORNO = T981.T$ORNO                           '
                                    + '    AND T941.T$PONO = T705.T$PONO                           '
                                    + '    AND T941.T$PONO = T981.T$PONO                           '
                                    + '    AND T705.T$CKON = 3') then
                    begin
                      cdsCMS.Append;
                      cdsCMS.FieldByName('NCMP').AsString := IntToStr(Par_NCMP);
                      cdsCMS.FieldByName('ORNO').AsString := Cds_Tmp.Fieldbyname('ORNO').Asstring;
                      cdsCMS.FieldByName('PONO').AsString := Cds_Tmp.Fieldbyname('PONO').Asstring;
                      cdsCMS.FieldByName('ITEM').AsString := Trim(T000.FieldByName('T$ITEM').AsString);
                      cdsCMS.FieldByName('REFD').AsString := Trim(T000.FieldByName('T$REFD').AsString);
                      cdsCMS.FieldByName('REFC').AsString := Trim(T000.FieldByName('T$REFC').AsString);
                      cdsCMS.FieldByName('CPON').AsString := Trim(T000.FieldByName('T$CPON').AsString);
                      cdsCMS.FieldByName('CPRT').AsString := Trim(T000.FieldByName('T$CPRT').AsString);
                      cdsCMS.FieldByName('CUMN').AsString := Trim(T000.FieldByName('T$CUMN').AsString);
                      cdsCMS.FieldByName('CITM').AsString := Trim(T000.FieldByName('T$CITM').AsString);
                      cdsCMS.FieldByName('CUIT').AsString := Trim(T000.FieldByName('T$CUIT').AsString);
                      cdsCMS.FieldByName('TREF').AsString := Trim(T000.FieldByName('T$TREF').AsString);
                      cdsCMS.FieldByName('COPO').AsString := Trim(T000.FieldByName('T$COPO').AsString);
                      cdsCMS.FieldByName('CSOL').AsString := Trim(T000.FieldByName('T$CSOL').AsString);
                      cdsCMS.FieldByName('SOLN').AsString := Trim(T000.FieldByName('T$SOLN').AsString);
                      cdsCMS.FieldByName('SLCD').AsString := Trim(T000.FieldByName('T$SLCD').AsString);
                      cdsCMS.FieldByName('RQDT').AsString := Trim(T000.FieldByName('T$RQDT').AsString);
                      cdsCMS.FieldByName('UPCC').AsString := Trim(T000.FieldByName('T$UPCC').AsString);
                      cdsCMS.FieldByName('DELG').AsString := Trim(T000.FieldByName('T$DELG').AsString);
                      cdsCMS.FieldByName('SOSL').AsString := Trim(T000.FieldByName('T$SOSL').AsString);
                      cdsCMS.FieldByName('SCIP').AsString := T000.FieldByName('T$SOSL').AsString;
                      cdsCMS.FieldByName('DDTA').AsDateTime := Par_DDTA;
                      cdsCMS.FieldByName('APAR').AsString := Par_APAR;
                      C022.FieldByName('REFD').Value := T000.Fieldbyname('T$REFD').Value;
                      C022.FieldByName('REFC').Value := T000.Fieldbyname('T$REFC').Value;
                      C022.FieldByName('REFN').Value := T000.Fieldbyname('T$REFN').Value;
                    end;
                  end;
                    C022.POST;
                    C022.ApplyUpdates;

                  //--------------------------Insert Data to CMPPS067-----------------//
                  if not (SEssion_constraint('ALLSESID', 'HAVE_CUST_ITEM') = 'Y') then
                    strITEM := Trim(Cds_Tmp.Fieldbyname('ITEM').AsString) else
                  begin
                    if CDS_Open(T000, '0SELECT T992.T$ORNO, T992.T$PONO, T992.T$SEQN,                                            '
                                    + '        Decode(LENGTH(LTRIM(RTRIM(T992.T$CITM))), NULL, T992.T$ITEM, T992.T$CITM) T$CITM, '
                                    + '        Decode(LENGTH(T993.T$OQUA), NULL, T992.T$OQUA, T993.T$OQUA) T$OQUA,               '
                                    + '        Decode(LENGTH(T993.T$QANA), NULL, 0, T993.T$QANA) T$QANA,                         '
                                    + '        Decode(T993.T$GPID, NULL, T992.T$COPO, T993.T$GPID) T$GPID,                       '
                                    + '        Decode(T993.T$COPO, NULL, T992.T$COPO, T993.T$COPO) T$COPO,                       '
                                    + '        Decode(LENGTH(LTRIM(RTRIM(T993.T$ITEM))), NULL, T992.T$ITEM, T993.T$ITEM) T$ITEM, '
                                    + '        Decode(LENGTH(LTRIM(RTRIM(T993.T$DSCA))), 0, NULL, T993.T$DSCA) T$DSCA            '
                                    + '   FROM TRITON.TTDSLS992' + Get000(IntToStr(Par_NCMP), 3) + ' T992,                       '
                                    + '        TRITON.TTDSLS993' + Get000(IntToStr(Par_NCMP), 3) + ' T993                        '
                                    + '  WHERE T992.T$ORNO = '+ Cds_Tmp.FieldByName('ORNO').AsString
                                    + '    AND T992.T$SEQN = 1                                                                   '
                                    + '    AND T992.T$PONO = '+ Cds_Tmp.FieldByName('PONO').AsString
                                    + '    AND T993.T$RODS (+) = T992.T$RODS                                                     '
                                    + '    AND T993.T$SEQN (+) = T992.T$SEQN                                                               '
                                    + '    AND T993.T$PONO (+) = T992.T$PONO') then
                    begin
                      while not T000.Eof do
                      begin
                        if (Length(Cds_Tmp.Fieldbyname('ITEM').Asstring) > 0) then
                        begin
                          if (Length(T000.FieldByName('T$CITM').AsString) > 0) then
                            strITEM := Trim(T000.Fieldbyname('T$CITM').asstring)
                          else if T000.FieldByName('T$COPO').AsString = T000.FieldByName('T$GPID').AsString then
                                 strITEM := Trim(Cds_Tmp.Fieldbyname('ITEM').Asstring);
                                 if not Cds_Open(C067, 'SELECT * FROM CMPPS067'
                                                     + ' WHERE NCMP = '+ IntToStr(Par_NCMP)
                                                     + '   AND ORNO = '+ Cds_Tmp.Fieldbyname('ORNO').Asstring
                                                     + '   AND PONO = '+ Cds_Tmp.Fieldbyname('PONO').Asstring
                                                     + '   AND COPO = '+ T000.FieldByName('T$COPO').AsString) then
                                   C067.Append
                                 else C067.Edit;
                                   C067.FieldByName('NCMP').AsInteger := Par_NCMP;
                                   C067.FieldByName('ORNO').Value := Cds_Tmp.Fieldbyname('ORNO').Asstring;
                                   C067.FieldByName('PONO').Value := Cds_Tmp.Fieldbyname('PONO').Asstring;
                                   C067.FieldByName('GPID').Value := T000.FieldByName('T$GPID').Value;
                                   C067.FieldByName('ITEM').Value := TRIM(Cds_Tmp.Fieldbyname('ITEM').Asstring);
                                   C067.FieldByName('DSCA').Value := T000.FieldByName('T$DSCA').Value;
                                   C067.FieldByName('OQUA').Value := Cds_Tmp.Fieldbyname('OQUA').Asstring;
                                   C067.FieldByName('COPO').Value := T000.FieldByName('T$COPO').Value;
                                   C067.FieldByName('SEQN').Value := T000.FieldByName('T$SEQN').Value;
                                   C067.FieldByName('QANA').Value := T000.FieldByName('T$QANA').Value;
                                   C067.FieldByName('CITM').Value := TRIM(T000.FieldByName('T$CITM').Value);
                                   C067.POST;
                                   C067.ApplyUPDATEs;
                        end else strITEM := Trim(Cds_Tmp.Fieldbyname('ITEM').Asstring);
                        T000.Next;
                      end;
                    end else strITEM := Trim(Cds_Tmp.Fieldbyname('ITEM').Asstring);
                  end;

                  //------------------Insert Data to CMPPS002----------//
                  if (SEssion_constraint('PPSM02S01', 'PACKING_STANDARD_DOWNLOAD') = 'Y') then
                  begin
                    Cds_Open(C002, 'SELECT * FROM CMPPS002 '
                                 + ' WHERE ITEM       = '+ QuotedStr(strITEM)
                                 + '   AND FINAL_MPAK = '+ QuotedStr(MPAK)
                                 + '   AND NCMP       = '+ IntToStr(Par_NCMP));
                    if C002.IsEmpty then
                    begin
                      if Q_Open(T000, '0SELECT * FROM TRITON.TTIITM950' + Get000(IntToStr(Par_NCMP), 3)
                                    + '  WHERE LTRIM(T$ITEM) = '+ QuotedStr(strITEM)) then
                      begin
                        while not T000.Eof do
                        begin
                          C002.Append;
                          C002.FieldByName('NCMP').Asinteger := Par_NCMP;
                          C002.FieldByName('RULE_ID').Asinteger := Assign_Number(IntToStr(Par_GRUP), 'RULE_ID');
                          C002.FieldByName('ITEM').asstring := strITEM;
                          C002.FieldByName('FINAL_MPAK').Value := T000.Fieldbyname('T$MPAK').Value;
                          C002.FieldByName('FINAL_QTY').Value := T000.Fieldbyname('T$QSPK').Value;
                          C002.FieldByName('DUNI').Value := T000.Fieldbyname('T$DUNI').Value;
                          C002.FieldByName('LENG').Value := T000.Fieldbyname('T$LENG').Value;
                          C002.FieldByName('WIDT').Value := T000.Fieldbyname('T$WIDT').Value;
                          C002.FieldByName('THIC').Value := T000.Fieldbyname('T$THIC').Value;
                          C002.FieldByName('WUNI').Value := T000.Fieldbyname('T$WUNI').Value;
                          C002.FieldByName('NWGT').Value := T000.Fieldbyname('T$NWGT').Value;
                          C002.FieldByName('GWGT').Value := T000.Fieldbyname('T$GWGT').Value;
                          C002.FieldByName('LWGT').Value := T000.Fieldbyname('T$LWGT').Value;
                          C002.FieldByName('CRTDATE').AsDateTime := Date;
                          C002.POST;
                          C002.ApplyUpdates;
                          T000.Next;
                        end;
                      end else
                      begin
                        Par_DSCA := 'Picking No: ' + IntToStr(Par_PINO) + '"' + strITEM + '",Can''t find Packing Standard in Triton.';
                        Show_Memo_Line_Data(format('--> %s Can''t find Packing Standard in Triton.',
                                                   [IntToStr(Par_NCMP) + ' / ' + IntToStr(Par_PINO) + ' : ' + strITEM]));
                        Update_Error_Log(Par_NCMP, Par_PINO, Par_CUNO, Par_DSCA);
                        Cds_CTmp.Next; Continue;
                      end;
                    end;
                  end;
            end;
              fp_InsertCMPPS08X(IntToStr(Par_NCMP), CDS_Tmp.FieldByName('ORNO').Value,CDS_Tmp.FieldByName('PINO').Value, CDS_Tmp.FieldByName('PONO').Value);
              CDS_Tmp.Next;
          end;
            Prepare_Set_Status(Par_NCMP, par_PINO);
            Show_Memo_Line_Data(Format('--> Picking Download Completed =   %s', [IntToStr(Par_NCMP) + '     ' +
            IntToStr(Par_PINO) + '     ' + IntToStr(Par_ORNO)]));
            DBCMS.Commit;
            Cds_CTmp.Next;
      end;
      Result := ff_Compare_Picking;
      if Result = 'Success' then
        Result := ''
      else abort;
      mCommit := True;
    except
    on E: Exception do
      begin
        Show_Memo_Line_Data('--> The Network May Disconnected, System Will Retry 30 seconds later');
      end;
    end;
    if mCommit then
      begin
        if C021.Active then C021.CommitUpdates;
        if C022.Active then C022.CommitUpdates;
        if C029.Active then C029.CommitUpdates;
        if C071.Active then C071.CommitUpdates;
      end;
  finally
    if DBCMS.Connected = True then DBCMS.Connected := False;
    Application.Terminate;
    FreeAndNil(C002);
    FreeAndNil(C021);
    FreeAndNil(C022);
    FreeAndNil(C029);
    FreeAndNil(C062);
    FreeAndNil(C066);
    FreeAndNil(C067);
    FreeAndNil(C071);
    FreeAndNil(C101);
    FreeAndNil(T000);
    FreeAndNil(T012);
    FreeAndNil(Cds_CTmp);
    FreeAndNil(Cds_Tmp);
    FreeAndNil(Cds_CSav);
    FreeAndNil(Cds_TTmp);
    FreeAndNil(cdsCMS);
  end;
    Next_Process;
end;

function Uf_Is_Auto_Process(Par_NCMP, Par_PKCD, Par_PTYP, Par_BTCPTYP_List, Par_AUTO_PROCESS_NCMP_LISTS: string): Boolean;
begin
  if (POS(Par_NCMP, Par_AUTO_PROCESS_NCMP_LISTS) > 0) and
    (POS(Par_PTYP, Par_BTCPTYP_List) > 0) and (Par_PKCD = 'CTN') then
    Result := True
  else Result := False;
end;

function TFrmReceivePicking_1.Prepare_Set_Status(Par_NCMP, Par_PINO: Integer): Boolean;
begin
  Result := False;
  with Cds_CSav do
    begin
      Close;
      Cds_CSav.Sql.Text := 'UPDATE RECEIVEPICKING    '
        + '   SET STATUS = 1        '
        + ' WHERE NCMP   = :NCMP    '
        + '   AND PINO   = :PINO';
      Params[000].Value := Par_NCMP;
      Params[001].Value := Par_PINO;
    end;
  if not Cds_Execute(DBCMS, Cds_CSav) then Exit;
  Result := True;
end;

function TFrmReceivePicking_1.Update_Error_Log(Par_NCMP, Par_PINO: Integer;
  Par_CUNO, Par_DSCA: string): Boolean;
begin
  Result := False;
  with Cds_CSav do
    begin
      Close;
      Cds_CSav.Sql.Text := 'INSERT INTO CMS.ERROR '
        + '       (LOGDATE, NCMP, CUNO, TYPE, CAPTION, MESSAGE, STATUS) '
        + 'VALUES (:LOGDATE, :NCMP, :CUNO, :TYPE, :CAPTION, :MESSAGE, :STATUS)';
      Params[000].Value := NOW;
      Params[001].Value := IntToStr(Par_NCMP);
      Params[002].Value := Par_CUNO;
      Params[003].Value := 'Receiving Picking';
      Params[004].Value := Par_DSCA;
      Params[005].Value := '';
      Params[006].Value := 'N';
    end;
  if not Cds_Execute(DBCMS, Cds_CSav) then Exit;
  Result := True;
end;

procedure TFrmReceivePicking_1.FormCreate(Sender: Tobject);
var
  Pt_IniFile: TiniFile;
  Ps_IniFile, Ps_IniFilePath: string;
begin
  Ps_IniFilePath := ExtractFilePath(Paramstr(0));
  Ps_IniFile := Ps_IniFilePath + 'ReceivePicking.Ini';
  if FileExists(Ps_IniFile) then
    begin
      Pt_IniFile := TiniFile.Create(Ps_Inifile);
      try
        DbTriton.Aliasname := Pt_IniFile.Readstring('Triton', 'Aliasname', 'WIH_Triton');
        DbTriton.Params.Strings[0] := 'User Name=' + Pt_IniFile.Readstring('Triton', 'User_Name', 'dbadmpps');
        DbTriton.Params.Strings[1] := 'Password=' + Pt_IniFile.Readstring('Triton', 'Password', 'dbadmpps');
        DbCms.Aliasname := Pt_IniFile.Readstring('CMS', 'Aliasname', 'WIH_CMS');
        DbCms.Params.Strings[0] := 'User Name=' + Pt_IniFile.Readstring('CMS', 'User_Name', 'Cms_User');
        DbCms.Params.Strings[1] := 'Password=' + Pt_IniFile.Readstring('CMS', 'Password', 'Cms_User');
        Us_LOGFILE_ON_OFF := Pt_IniFile.Readstring('LOGFILE', 'ON/OFF', 'OFF');
        Us_LOGFILE_PATH := Pt_IniFile.Readstring('LOGFILE', 'PATH', Ps_IniFilePath);
        if Us_LOGFILE_PATH = '' then Us_LOGFILE_PATH := Ps_IniFilePath;
      finally
        if Assigned(Pt_IniFile) then Pt_IniFile.Free;
      end;
    end;
end;

procedure TFrmReceivePicking_1.Show_Memo_Line_Data(Par_Momo_Data: string);
begin
  Memo_Receive_Picking_Data.Lines.Add(Par_Momo_Data);
  Application.ProcessMessages;
end;

function TFrmReceivePicking_1.Create_Cds(Par_DbName: string; Par_Owner: Tcomponent; const Par_Name: string = ''): Tquery;
begin
  Result := Tquery.Create(Par_Owner);
  Result.DatabaseName := Par_DbName;
  Result.Sql.Text := '';
  Result.SessionName := Qds_Session.SessionName;
  if Par_Name <> '' then Result.Name := Par_Name;
  Result.Onupdateerror := Update_Cds_Error;
end;

procedure TFrmReceivePicking_1.Update_Cds_Error(DataSet: Tdataset; E: EDataBaseError; UpdateKind: TUpdateKind; var UpdateAction: TUpdateAction);
begin
  case UpdateKind of
    Ukmodify: UpdateAction := UAapplied;
    Ukinsert: UpdateAction := UAapplied;
    Ukdelete: UpdateAction := UAapplied;
  end;
end;

function TFrmReceivePicking_1.Cds_Open(Par_Cds: Tquery; Par_Sql: string): Boolean;
var
  Fb_Readonly: Boolean;
begin
  Par_Cds.Close;
  Result := False;
  Fb_Readonly := True;
  Par_Sql := Trim(Par_Sql);
  if Par_Sql[1] = '0' then
    begin
      Par_Sql := Copy(Par_Sql, 2, Length(Par_Sql) - 1);
      Fb_Readonly := False;
    end;
  Par_Cds.Sql.Clear;
  Par_Cds.Sql.Text := Par_Sql;
  Par_Cds.Cachedupdates := Fb_Readonly;
  Par_Cds.Requestlive := Fb_Readonly;
  try
    Par_Cds.Open;
  except
  //on E: Exception do begin
  //  Show_Memo_Line_Data('  The Network May Disconnected, System Will Retry Later');
  //end;
  end;
  if not Par_Cds.Isempty then Result := True;
end;

function TFrmReceivePicking_1.Cds_Execute(var Par_CdsDb: Tdatabase; var Par_Cds: Tquery): Boolean;
begin
  Result := True;
  if Par_Cds = nil then Exit;
  try
    Par_Cds.RequestLive := True;
    Par_Cds.CachedUpdates := True;
    Par_Cds.ExecSQL;
    Par_Cds.Close;
    Par_Cds.Sql.Clear;
  except
    on E: Exception do
      begin
        Memo_Receive_Picking_Data.Lines.Add(#9 + #9 + 'The Statement Raised Error as ..'
          + #13 + '<Error Description> ' + E.Message
          + #13 + '<Sql Statement> ' + Par_Cds.Sql.Text);
        Par_CdsDb.Rollback;
        Result := False;
      end;
  end;
end;

function TFrmReceivePicking_1.Q_Open(MYquery: Tquery; mSQL: string): Boolean;
var
  Ronly: Boolean;
begin
  MyQuery.Close;
  Result := false;
  Ronly := True;
  mSQL := Trim(mSQL);
  if mSQL[1] = '0' then
    begin
      MSQL := Copy(MSQL, 2, Length(mSQL) - 1);
      Ronly := False;
    end;
  MyQuery.SQL.Clear;
  MyQuery.SQL.text := mSQL;
  MYquery.CachedUpdates := Ronly;
  MyQuery.RequestLive := Ronly;
  try
    MyQuery.Open;
  except
  //on E: Exception do begin
  //  Show_Memo_Line_Data('  The Network May Disconnected, System Will Retry 30 seconds later');
  //end;
  end;
  if not mYQuery.IsEmpty then Result := true;
end;

procedure TFrmReceivePicking_1.Q_Execute(MYquery: Tquery; mSQL: string);
begin
  MyQuery.Close;
  MyQuery.CachedUpdates := False;
  MyQuery.RequestLive := true;
  MyQuery.SQL.Clear;
  MyQuery.SQL.text := mSQL;
  Myquery.ExecSQL;
end;

function TFrmReceivePicking_1.GetLine(var MultiLines: Variant; N: integer): string;
begin
  Result := '';
  if N <= VararrayHighBound(MultiLines, 1) then Result := MultiLines[N];
end;

function TFrmReceivePicking_1.Session_Constraint(Par_ses, Par_constra: WideString; const Par_Para: WideString = ''): WideString;
var
  TMP: Tquery;
begin
  Result := '';
  TMP := CreateQuery('CMS', nil);
  try
    if Q_Open(TMP, '0Select CONVALUE, EXTENSION'
      + '   From CMPPS105'
      + '  Where SESID = ' + QuotedStr(Par_SES)
      + '    And CONNAME = ' + QuotedStr(Par_Constra)
      + '    And COMPID = ' + inttostr(par_NCMP))
      then Result := TMP.Fieldbyname('CONVALUE').AsString;
    if (Par_PARA <> '') and (TMP.fieldbyname('EXTENSION').AsString = 'Y') then
      if Q_Open(TMP, '0Select PARA, CONVALUE'
        + '   From CMPPS1051'
        + '  Where SESID = ' + QuotedStr(Par_SES)
        + '    And CONNAME = ' + QuotedStr(Par_Constra)
        + '    And COMPID = ' + inttostr(par_NCMP))
        and hasinLines(TMP.Fieldbyname('PARA').AsString, Par_PARA)
        then Result := TMP.Fieldbyname('CONVALUE').AsString
      else Result := '';
  finally
    TMP.close;
    TMP.Free;
  end;
end;

function TFrmReceivePicking_1.Assign_Number(const GroupNCMP, PARA: WideString): Integer;
var
  C012: Tquery;
begin
  Result := 0;
  C012 := CreateQuery('CMS', nil);
  try
    Q_execute(C012, 'UPdate CMPPS012'
      + '   Set SERI_NO = SERI_NO + 1'
      + ' Where NCMP = ' + GroupNCMP
      + '   And PARM = ' + QuotedStr(PARA));
    if Cds_Open(C012, 'Select *'
      + '  From CMPPS012'
      + ' Where NCMP = ' + GroupNCMP
      + '   And PARM = ' + QuotedStr(PARA)) then
      begin
        if length(C012.FieldByName('SERI_NO').AsString) > C012.FieldByName('MAX_LEN').AsInteger then
          begin
            C012.Edit;
            C012.FieldByName('SERI_NO').AsInteger := 1;
            C012.ApplyUpdates;
          end;
        Result := C012.FieldByName('SERI_NO').AsInteger;
      end;
  finally
    C012.close;
    C012.free;
  end;
end;

function TFrmReceivePicking_1.CreateQuery(mDBname: string; mOWNER: Tcomponent; const mName: string = ''): Tquery;
begin
  //------------- Create Tquery --
  Result := Tquery.Create(mOWner);
  Result.Databasename := mDBname;
  Result.SQL.Text := '';
  Result.SessionName := QDS_Session.SessionName;
  if mNAME <> '' then Result.name := mName;
  //------------- Update Events --
  Result.OnUpdateError := QueryUpdateError;
end;

procedure TFrmReceivePicking_1.QueryUpdateError(DataSet: TDataSet; E: EDatabaseError;
  UpdateKind: TUpdateKind; var UpdateAction: TUpdateAction);
begin
  case UpdateKind of
    ukModify: ;
    ukInsert: UpdateACtion := uaApplied;
    ukDelete: UpdateACtion := uaApplied;
  end;
end;

procedure TFrmReceivePicking_1.FormActivate(Sender: TObject);
begin
  Show_Memo_Line_Data('  Receiving Picking List Data....Queue 1                            ');
  Show_Memo_Line_Data('                                                                    ');
  Show_Memo_Line_Data('    Action Status               NCMP   Picking #    SO #            ');
  Show_Memo_Line_Data('  ----------------------------------------------------------------------------------- ');
  Show_Memo_Line_Data('                                                                    ');
  Receive_Picking_Data;
end;

procedure TFrmReceivePicking_1.Next_Process;
var
  Ps_LogFile, Ps_LogFilePath: string;
  i: Integer;
begin
  if UpperCase(Us_LOGFILE_ON_OFF) = 'ON' then
  begin
    Ps_LogFilePath := Us_LOGFILE_PATH + 'ReceivePicking_Log';
    if not DirectoryExists(Ps_LogFilePath) then
      ForceDirectories(Ps_LogFilePath);
    Ps_LogFile := Ps_LogFilePath + '\' + FormatDateTime('YYYYMMDD', Now) + '.Log_1';
    if not DirectoryExists(Ps_LogFile) then Memo_Receive_Picking_Data.Lines.SaveToFile(Ps_LogFile);
  end;
  begin
    For i := 1 to 30 do
    begin
      Count.Text := IntToStr(i);
      Status_Bar.Text := 'Waiting For 30 Seconds .............';
      Application.ProcessMessages;
      Sleep(1000);
    end;
  end;
  Status_Bar.Text := 'Searching New Picking List Now .........';
  Receive_Picking_Data;
end;

procedure TFrmReceivePicking_1.Timer1Timer(Sender: TObject);
begin
  Timer1.Interval := 600000;
  SetProcessWorkingSetSize(GetCurrentProcess, $FFFFFF, $FFFFFF);
end;

procedure TFrmReceivePicking_1.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
//  Close;
end;

end.
